# zdnet.tcl v1.2 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check www.uid-zero.de
#
# das  tcl liest  die zdnet.de gaming news  aus und gibt sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.2 - komplett umgebaut by public request
#      - link wird gleich mitgepostet
#      - yeah  endlich  keine  windrop  user  mehr die mich fragen was lynx ist
#        so gerne ich support leiste - jeden tag ne  mail mit der  selben frage
#        stresst ziemlich ;)
#
# zdnettrigger - der trigger auf den der bot reagiert (public und message)
# zdnetlimit - maximum der news die auf befehl geposted werden
# zdnetnewspost  - 1 fr newsposting, 0 fr keines
# zdnetchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# zdnetnewspostlimit - maximum der news die geposted werden
# zdnetdehub  - legt fest ob der bot newshub ist oder nicht
# zdnetleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set zdnettrigger ".zdnet"
set zdnetchans ""
set zdnetlimit "3"
set zdnetnewspostlimit "5"
set zdnetnewspost "1"
set iszdnethub "0"
set zdnetleafs ""

####### ende der config #############

bind msg - $zdnettrigger msg_zdnet
bind pub - $zdnettrigger pub_zdnet
bind time - "?0 * * * *" zdnetcheck

proc sendzdnetnews { arg } {
global zdnetleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $zdnetleafs] [string tolower $bot]] != -1)} {
putbot $bot "zdnet: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc zdnetnews { target limit } {
if {[catch {set sock [socket news.zdnet.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Microsoft owns, Netscape suxx"
puts $sock "Host: news.zdnet.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]

if {[string first "class=\"nd\"><b class=\"a4\">" $bl] != -1} {
set link "http://news.zdnet.de[string range $bl [shrink + 1 "\"" 0 $bl] [shrink - 1 "\" class" 0 $bl]]"
set newsline [string range $bl [shrink + 3 "4\">" 0 $bl] [shrink - 1 "</b>" 0 $bl]]

putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc zdnetcheck {nick uhost hand chan arg} {
global zdnetchans zdnetnewspost iszdnethub zdnetnewspostlimit
set counter 0
if {$zdnetnewspost == 1 } {
putlog "zdnet: suche nach neuer newsline"
set zdnetlastnews "none"
if {[file exists zdnet.hdl]} {
set temp [open "zdnet.hdl" r]
set zdnetlastnews "[gets $temp]"
if {$zdnetlastnews == ""} { set zdnetlastnews "none" }
close $temp
}
set temp [open "zdnet.hdl" w+]
if {[catch {set sock [socket news.zdnet.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Microsoft owns, Netscape suxx"
puts $sock "Host: news.zdnet.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"nd\"><b class=\"a4\">" $bl] != -1} {
set link "http://news.zdnet.de[string range $bl [shrink + 1 "\"" 0 $bl] [shrink - 1 "\" class" 0 $bl]]"
set newsline [string range $bl [shrink + 3 "4\">" 0 $bl] [shrink - 1 "</b>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$zdnetlastnews == "none" } { putlog "zdnet: headlinefile created" ; return 0 }
set temp [open "zdnet.hdl" r]
while { [eof $temp] != 1 } {
set zdnetneunews [gets $temp]
if {($zdnetlastnews == $zdnetneunews) || ($counter == $zdnetnewspostlimit)} { close $temp;return 0 }
incr counter
if { $iszdnethub == "1" } { sendzdnetnews $zdnetneunews }
foreach chan [channels] {
if {$zdnetchans == "" } { putserv "privmsg $chan :(neue zdnet newsline) $zdnetneunews" }
if {$zdnetchans != "" } {
if {([lsearch -exact [string tolower $zdnetchans] [string tolower $chan]] != -1) || ($zdnetchans == "")} {putserv "privmsg $chan :(neue zdnet newsline) $zdnetneunews"}
}
}}}}


proc msg_zdnet { nick uhost hand arg } { global zdnetlimit ; zdnetnews $nick $zdnetlimit }
proc pub_zdnet { nick uhost hand chan arg } { global zdnetchans zdnetlimit ; if {([lsearch -exact [string tolower $zdnetchans] [string tolower $chan]] != -1) || ($zdnetchans == "")} { zdnetnews $nick $zdnetlimit }}


putlog "*** zdnet.tcl v1.2 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
